// ._________________________________________________.
// |     ___   _   ____. .____   .   .   _   .__     |
// |    /     / \     /  |       |\ /|  / \  |  \    |
// |   {  _  {---}   /   |__     | v | {   } |   }   |
// |   {   \ |   |  /    |       |   | {   } |   }   |
// |    \__/ |   | {____ |____   |   |  \_/  |__/    |
// |_________________________________________________|
// |                                                 |
// |  Build 2.3.1  Scripted by Xalos (BL_ID: 11239)  |
// |_________________________________________________|



// ._________________________.
// |   __    _   .__   .____ |
// |  /  \  / \  |  \  |     |
// | {     {   } |   } |__   |
// | {     {   } |   } |     |
// |  \__/  \_/  |__/  |____ |
// |_________________________|

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	//Preference name, section, variable, type, add-on, default value, requires restart, host-only, update function.
	RTB_registerPref("Sight Range", "Gaze", "$Pref::Server::GazeRange", "int 0 100", "Server_Gaze", 20, 0, 0);//, "update function");
	RTB_registerPref("Allow onGaze", "Gaze", "$Pref::Server::onGazeEnabled", "bool", "Server_Gaze", 1, 0, 0);//, "update function");
	RTB_registerPref("Gaze Mode", "Gaze", "$Pref::Server::GazeMode", "list Bricks,Players,andBots 3 BricksOnly 2 PlayersandBots 1 Sightless 0", "Server_Gaze", 3, 0, 0);//, "update function");
}
else
{
	if($Pref::Server::GazeRange $= "" || $Pref::Server::GazeRange < 0 || $Pref::Server::GazeRange > 100)
		$Pref::Server::GazeRange = 20;
	if($Pref::Server::onGazeEnabled $= "")
		$Pref::Server::onGazeEnabled = 1;
	if($Pref::Server::GazeMode $= "")
		$Pref::Server::GazeMode = 3;
}
registerInputEvent("fxDtsBrick", "onGaze", "Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame");
registerInputEvent("fxDtsBrick", "onGazeStart", "Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame");
registerInputEvent("fxDtsBrick", "onGazeStop", "Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame");
registerInputEvent("fxDtsBrick", "onGazeStartFirst", "Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame");
registerInputEvent("fxDtsBrick", "onGazeStopLast", "Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame");
registerInputEvent("fxDtsBrick", "onGaze_Bot", "Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame\tBot Player");
registerInputEvent("fxDtsBrick", "onGazeStart_Bot", "Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame\tBot Player");
registerInputEvent("fxDtsBrick", "onGazeStop_Bot", "Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame\tBot Player");
registerOutputEvent("fxDtsBrick", "setGazeName", "string 200 255", 0);

function fxDtsBrick::setGazeName(%brick, %name)
{
//	while((%temp = stripMLControlChars(%name)) !$= %name)
//		%name = %temp;
	%brick.gazeName = %name;
}

function GameConnection::startGazing(%cl)
{ %cl.cantGaze = 0; }

function GameConnection::stopGazing(%cl)
{ cancel(%cl.startGazing); %cl.cantGaze = 1; }

function Player::gazeLoop(%this)
{
	cancel(%this.gazeLoop);   //Kill off duplicate processes if any are trailing behind us.
	if(!isObject(%this) || !isObject(%this.client))
		return;
	if(%this.getState() $= "Dead")
	{
		if(isObject(%this.client.lastGazed))
		{
			//These events are really fucking abusable - admin wand immunity.
			//Disabled the wand immunity because it breaks events.
			//if(%this.hasWandImmunity(%this.client.lastGazed))
			//	return;
			$InputTarget_Player = %this;
			$InputTarget_Client = %this.client;
			if($Server::LAN || getMinigameFromObject(%last = %this.client.lastGazed) == getMinigameFromObject(%this.client))
				$InputTarget_Minigame = getMinigameFromObject(%this.client);
			else
				$InputTarget_Minigame = 0;
			if(%last.getClassName() $= "fxDtsBrick")
			{
				$InputTarget_Self = %last;
				%last.processInputEvent("onGazeStop", %cl);
				if(%last.getGazeCount() == 1)
					%last.processInputEvent("onGazeStopLast", %cl);
			}
			else if(%last.getClassName() $= "AIPlayer" && isObject(%last.spawnBrick))
			{
				$InputTarget_Self = %last.spawnBrick;
				$InputTarget_Bot = %last;
				%last.spawnBrick.processInputEvent("onGazeStop_Bot");
			}
			%this.client.lastGazed = "";
		}
	}
	%this.gazeLoop = %this.schedule(10, "gazeLoop");
	%eye = vectorScale(%this.getEyeVector(), $Pref::Server::GazeRange);
	%pos = %this.getEyePoint();
	%mask = $TypeMasks::TerrainObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::FxBrickObjectType;
	%hit = firstWord(containerRaycast(%pos, vectorAdd(%pos, %eye), %mask, %this));
	%cl = %this.client;
	%last = %cl.lastGazed;
	if(!isObject(%hit))
	{
		if(isObject(%last))
		{
			if(!%cl.cantGaze) commandToClient(%cl, 'clearBottomPrint');
			//These events are really fucking abusable - admin wand immunity.
			//Disabled the wand immunity because it breaks events.
			//if(%this.hasWandImmunity(%last))
			//	return;
			$InputTarget_Player = %this;
			$InputTarget_Client = %cl;
			if($Server::LAN || getMinigameFromObject(%last) == getMinigameFromObject(%cl))
				$InputTarget_Minigame = getMinigameFromObject(%cl);
			else
				$InputTarget_Minigame = 0;
			if(%last.getClassName() $= "fxDtsBrick")
			{
				$InputTarget_Self = %last;
				%last.processInputEvent("onGazeStop", %cl);
				if(%last.getGazeCount() == 1)
					%last.processInputEvent("onGazeStopLast", %cl);
			}
			else if(%last.getClassName() $= "AIPlayer" && isObject(%last.spawnBrick))
			{
				$InputTarget_Self = %last.spawnBrick;
				$InputTarget_Bot = %last;
				%last.spawnBrick.processInputEvent("onGazeStop_Bot", %cl);
			}
			%cl.lastGazed = "";
		}
		return;
	}
	if(%hit != %last)
	{
		if(isObject(%last))
		{
			if(!%cl.cantGaze) commandToClient(%cl, 'clearBottomPrint');
			$InputTarget_Player = %this;
			$InputTarget_Client = %cl;
			if($Server::LAN || getMinigameFromObject(%last) == getMinigameFromObject(%cl))
				$InputTarget_Minigame = getMinigameFromObject(%cl);
			else
				$InputTarget_Minigame = 0;
			if(%last.getClassName() $= "fxDtsBrick")
			{
				$InputTarget_Self = %last;
				%last.processInputEvent("onGazeStop", %cl);
				if(%last.getGazeCount() == 1)
					%last.processInputEvent("onGazeStopLast", %cl);
			}
			else if(%last.getClassName() $= "AIPlayer" && isObject(%last.spawnBrick))
			{
				$InputTarget_Self = %last.spawnBrick;
				$InputTarget_Bot = %last;
				%last.spawnBrick.processInputEvent("onGazeStop_Bot", %cl);
			}
		}
		if(%hit.getClassName() $= "fxDtsBrick")
		{
			if($Pref::Server::GazeMode & 2)
			{
				//These events are really fucking abusable - admin wand immunity.
				if(%this.hasWandImmunity(%hit))
					return;
				$InputTarget_Self = %hit;
				$InputTarget_Player = %this;
				$InputTarget_Client = %cl;
				if($Server::LAN || getMinigameFromObject(%hit) == getMinigameFromObject(%cl))
					$InputTarget_Minigame = getMinigameFromObject(%cl);
				else
					$InputTarget_Minigame = 0;
				%hit.processInputEvent("onGazeStart", %cl);
				if(%hit.getGazeCount() == 0)
					%hit.processInputEvent("onGazeStartFirst", %cl);
			}
		}
		else if(%hit.getClassName() $= "AIPlayer" && isObject(%spawn = %hit.spawnBrick))
		{
			if($Pref::Server::GazeMode & 1)
			{
				//These events are really fucking abusable - admin wand immunity.
				if(%this.hasWandImmunity(%hit))
					return;
				$InputTarget_Self = %spawn;
				$InputTarget_Player = %this;
				$InputTarget_Client = %cl;
				$InputTarget_Bot = %hit;
				if($Server::Lan || getMinigameFromObject(%hit) == getMinigameFromObject(%cl))
					$InputTarget_Minigame = getMinigameFromObject(%cl);
				else
					$InputTarget_Minigame = 0;
				%spawn.processInputEvent("onGazeStart_Bot", %cl);
			}
		}
		else if(!%cl.cantGaze)
			commandToClient(%cl, 'clearBottomPrint');
		%cl.lastGazed = %hit;
	}
	%name = %hit.getGazeName(%cl);
	if(%name !$= "" && !%cl.cantGaze)
		if((%hit.getClassName() $= "Player" && $Pref::Server::GazeMode & 1) || (%hit.getClassName() $= "fxDtsBrick" && $Pref::Server::GazeMode & 2))
		{ %cl.gazing = 1; %cl.bottomPrint("\c6"@%name, 2, 1); %cl.gazing = 0; }
}

function fxDtsBrick::getGazeCount(%brick)
{
	%count = ClientGroup.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%cl = ClientGroup.getObject(%i);
		if(%cl.lastGazed == %brick)
			%gazers++;
	}
	return %gazers + 0;
}

// Scripters wanting to change the gazing system should package this
function SimObject::getGazeName(%this, %gazer)
{
	switch$(%this.getClassName())
	{
		case "Player":
			if(%this.client == %gazer || %gazer.player == %this || !($Pref::Server::GazeMode & 1))
				return "";
			return %this.client.name;
		case "fxDtsBrick":
			if(!($Pref::Server::GazeMode & 2))
				return "";
			//These events are really fucking abusable - admin wand immunity.
			if(isObject(%gazer.player) && !%gazer.player.hasWandImmunity(%this))
			{
				$InputTarget_Self = %this;
				$InputTarget_Player = %gazer.player;
				$InputTarget_Client = %gazer;
				if($Server::LAN || getMinigameFromObject(%this) == getMinigameFromObject(%gazer))
					$InputTarget_Minigame = getMinigameFromObject(%gazer);
				else
					$InputTarget_Minigame = 0;
				%this.processInputEvent("onGaze", %gazer);
			}
			return %this.gazeName;
		case "AIPlayer":
			if(!($Pref::Server::GazeMode & 1))
				return "";
			//These events are really fucking abusable - admin wand immunity.
			if(isObject(%spawn = %this.spawnBrick) && isObject(%gazer.player) && !%gazer.player.hasWandImmunity(%spawn))
			{
				$InputTarget_Self = %spawn;
				$InputTarget_Player = %gazer.player;
				$InputTarget_Client = %gazer;
				$InputTarget_Bot = %this;
				if($Server::LAN || getMinigameFromObject(%spawn) == getMinigameFromObject(%gazer))
					$InputTarget_Minigame = getMinigameFromObject(%gazer);
				else
					$InputTarget_Minigame = 0;
				%spawn.processInputEvent("onGaze_Bot", %gazer);
			}
		default:
			return "";
	}
}

function Player::hasWandImmunity(%pl, %brick)
{
	if(!isObject(%tool = %pl.getMountedImage(0)))
		return 0;
	if(%tool.getName() $= "AdminWandImage")
		return 1;
	if(%tool.getName() $= "WandImage" && isObject(%brick) && isObject(%pl.client) && %brick.getGroup().getID() == %pl.client.brickgroup.getID())
		return 1;
	return 0;
}

package gaze
{
	function GameConnection::createPlayer(%cl, %trans)
	{
		Parent::createPlayer(%cl, %trans);
		if(isObject(%cl.player))
			%cl.player.gazeLoop();
	}
	
	function GameConnection::bottomPrint(%cl, %msg, %time, %box)
	{
		if(!%cl.gazing)
		{
			%cl.stopGazing();
			if(%time <= 0)
				%cl.startGazing = %cl.schedule(60000, "startGazing");   //Cap time of one minute. That's long enough for any useful info.
			else
				%cl.startGazing = %cl.schedule(%time * 1000, "startGazing");
		}
		Parent::bottomPrint(%cl, %msg, %time, %box);
	}
	
	function GameConnection::onClientLeaveGame(%cl)
	{
		if(isObject(%last = %cl.lastGazed))
		{
			commandToClient(%cl, 'clearBottomPrint');
			//These events are really fucking abusable - admin wand immunity.
			//Disabled the wand immunity because it breaks events.
			//if(%this.hasWandImmunity(%last))
			//	return;
			$InputTarget_Player = %this;
			$InputTarget_Client = %cl;
			if($Server::LAN || getMinigameFromObject(%last) == getMinigameFromObject(%cl))
				$InputTarget_Minigame = getMinigameFromObject(%cl);
			else
				$InputTarget_Minigame = 0;
			if(%last.getClassName() $= "fxDtsBrick")
			{
				$InputTarget_Self = %last;
				%last.processInputEvent("onGazeStop", %cl);
				if(%last.getGazeCount() == 1)
					%last.processInputEvent("onGazeStopLast", %cl);
			}
			else if(%last.getClassName() $= "AIPlayer" && isObject(%last.spawnBrick))
			{
				$InputTarget_Self = %last.spawnBrick;
				$InputTarget_Bot = %last;
				%last.spawnBrick.processInputEvent("onGazeStop_Bot", %cl);
			}
			%cl.lastGazed = "";
		}
		Parent::onClientLeaveGame(%cl);
	}
};
activatePackage("gaze");